clang 10.0.0git

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::OMPCollapseClause Class Reference

This represents 'collapse' clause in the '#pragma omp ...' directive. More...

`#include "clang/AST/OpenMPClause.h"`

Inheritance diagram for clang::OMPCollapseClause:
[legend]
Collaboration diagram for clang::OMPCollapseClause:
[legend]

## Public Member Functions
| OMPCollapseClause (Expr *Num, SourceLocation StartLoc, SourceLocation LParenLoc, SourceLocation EndLoc)
| Build 'collapse' clause. More...
| OMPCollapseClause ()
| Build an empty clause. More...
void | setLParenLoc (SourceLocation Loc)
| Sets the location of '('. More...
SourceLocation | getLParenLoc () const
| Returns the location of '('. More...
Expr * | getNumForLoops () const
| Return the number of associated for-loops. More...
child_range | children ()
const_child_range | children () const
child_range | used_children ()
const_child_range | used_children () const
Public Member Functions inherited from clang::OMPClause
SourceLocation | getBeginLoc () const
| Returns the starting location of the clause. More...
SourceLocation | getEndLoc () const
| Returns the ending location of the clause. More...
void | setLocStart (SourceLocation Loc)
| Sets the starting location of the clause. More...
void | setLocEnd (SourceLocation Loc)
| Sets the ending location of the clause. More...
OpenMPClauseKind | getClauseKind () const
| Returns kind of OpenMP clause (private, shared, reduction, etc.). More...
bool | isImplicit () const
child_range | children ()
const_child_range | children () const
child_range | used_children ()
| Get the iterator range for the expressions used in the clauses. More...
const_child_range | used_children () const

## Static Public Member Functions
static bool | classof (const OMPClause *T)
Static Public Member Functions inherited from clang::OMPClause
static bool | classof (const OMPClause *)

## Friends
class | OMPClauseReader

## Additional Inherited Members
Public Types inherited from clang::OMPClause
using | child_iterator = StmtIterator
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >
Protected Member Functions inherited from clang::OMPClause
| OMPClause (OpenMPClauseKind K, SourceLocation StartLoc, SourceLocation EndLoc)

## Detailed Description

This represents 'collapse' clause in the '#pragma omp ...' directive.

#pragma omp simd collapse(3)

In this example directive '#pragma omp simd' has clause 'collapse' with single expression '3'. The parameter must be a constant positive integer expression, it specifies the number of nested loops that should be collapsed into a single iteration space.

Definition at line 800 of file OpenMPClause.h.

## Constructor & Destructor Documentation

## ◆ OMPCollapseClause() [1/2]

clang::OMPCollapseClause::OMPCollapseClause | ( | Expr * | Num,
|  | SourceLocation | StartLoc,
|  | SourceLocation | LParenLoc,
|  | SourceLocation | EndLoc
| ) |  |
| inline

Build 'collapse' clause.

Parameters

  Num | Expression associated with this clause.
  StartLoc | Starting location of the clause.
  LParenLoc | Location of '('.
  EndLoc | Ending location of the clause.

Definition at line 819 of file OpenMPClause.h.

## ◆ OMPCollapseClause() [2/2]

clang::OMPCollapseClause::OMPCollapseClause | ( |  | ) |
| inline explicit

Build an empty clause.

Definition at line 825 of file OpenMPClause.h.

## Member Function Documentation

## ◆ children() [1/2]

child_range clang::OMPCollapseClause::children | ( |  | ) |
| inline

Definition at line 837 of file OpenMPClause.h.

## ◆ children() [2/2]

const_child_range clang::OMPCollapseClause::children | ( |  | ) | const
| inline

Definition at line 839 of file OpenMPClause.h.

## ◆ classof()

static bool clang::OMPCollapseClause::classof | ( | const OMPClause * | T | ) |
| inline static

Definition at line 850 of file OpenMPClause.h.

References clang::OMPClause::getClauseKind().

## ◆ getLParenLoc()

SourceLocation clang::OMPCollapseClause::getLParenLoc | ( |  | ) | const
| inline

Returns the location of '('.

Definition at line 832 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getNumForLoops()

Expr* clang::OMPCollapseClause::getNumForLoops | ( |  | ) | const
| inline

Return the number of associated for-loops.

Definition at line 835 of file OpenMPClause.h.

Referenced by OMPNontemporalClause::setPrivateRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ setLParenLoc()

void clang::OMPCollapseClause::setLParenLoc | ( | SourceLocation | Loc | ) |
| inline

Sets the location of '('.

Definition at line 829 of file OpenMPClause.h.

Referenced by clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## ◆ used_children() [1/2]

child_range clang::OMPCollapseClause::used_children | ( |  | ) |
| inline

Definition at line 843 of file OpenMPClause.h.

## ◆ used_children() [2/2]

const_child_range clang::OMPCollapseClause::used_children | ( |  | ) | const
| inline

Definition at line 846 of file OpenMPClause.h.

## Friends And Related Function Documentation

## ◆ OMPClauseReader

friend class OMPClauseReader
| friend

Definition at line 801 of file OpenMPClause.h.

The documentation for this class was generated from the following file:

- include/clang/AST/OpenMPClause.h